/*
 * Copyright (c) 2008 Hans - Joachim Borchers
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef DRVEEPROM_H_
#define DRVEEPROM_H_

#include "typedef.h"
#include "sysdef.h"

typedef struct T_EEPROM 
{
  u08 uUsedGuns;
  u08 uNomScreen;
  u16 uGunOff[2];
  u16 uNominalTemp[2];
  u16 uCalLow[2];
  u16 uCalHigh[2];
  u16 fKp[2];
  u16 fKi[2];
  u16 fKd[2];
  u16 uCrc;
} T_EEPROM;

typedef struct T_PARAM_ALL
{
  T_EEPROM *tEeprom;
  u08      uActGun;
}T_PARAM_ALL;

u08 drveeprom_InitModule( void );
T_PARAM_ALL *drveeprom_GetParameter( void );
void drveeprom_Write( void );
void drveeprom_Update( void );
u08 drveeprom_ChecksumError( void );


#endif /*DRVEEPROM_H_*/
